/*
calctick Version 0.7.0 - Calculate Ticks Per Second
Copyright (C) 2001,2002  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <time.h>
#include <sys/times.h>

int main()
   {
   unsigned int diff;
   time_t frstsec,currsec;
   clock_t prev,clk;
   struct tms t;
   /* get first date & time in seconds */
   time(&frstsec);
   currsec = frstsec;
   while (currsec == frstsec)
      {
      /* get first date & time in seconds */
      time(&currsec);
      } /* loop until second starts */
   /* get first clock ticks since boot */
   prev = times(&t);
   frstsec = currsec;
   while (currsec == frstsec)
      {
      /* get current date & time in seconds */
      time(&currsec);
      } /* loop for 1 second */
   /* get clock ticks since boot */
   clk = times(&t);
   if (clk < prev)
      {
      fprintf(stderr,"Negative ticks, rerun job\n");
      exit(0);
      }
   diff = clk - prev;
   printf("Ticks per second %d\n", diff);
   return(0);
   } /* main */
